//
//  ViewController.m
//  二维码扫码器
//
//  Created by 高备资产 on 16/5/13.
//  Copyright © 2016年 高备资产. All rights reserved.
//

#import "ViewController.h"
#import <AVFoundation/AVFoundation.h>
#import "ViewController2.h"

@interface ViewController ()<AVCaptureMetadataOutputObjectsDelegate>
{
    int num;
    BOOL upOrdown;
    NSTimer * timer;
    
    UIView *_line;
    
    float left;
    float top;
}

@property (strong,nonatomic)AVCaptureDevice *device;
@property (strong,nonatomic)AVCaptureDeviceInput *input;
@property (strong,nonatomic)AVCaptureMetadataOutput *output;
@property (strong,nonatomic)AVCaptureSession *session;
@property (strong,nonatomic)AVCaptureVideoPreviewLayer *preview;

@end


@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    // Device
    self.device = [AVCaptureDevice defaultDeviceWithMediaType:AVMediaTypeVideo];
    
    // Input
    self.input = [AVCaptureDeviceInput deviceInputWithDevice:self.device error:nil];
    
    // Output
    self.output = [[AVCaptureMetadataOutput alloc]init];
    [self.output setMetadataObjectsDelegate:self queue:dispatch_get_main_queue()];
    
    // Session
    self.session = [[AVCaptureSession alloc]init];
    [self.session setSessionPreset:AVCaptureSessionPresetHigh];
    if ([self.session canAddInput:self.input]){
        [self.session addInput:self.input];
    }
    if ([self.session canAddOutput:self.output])
    {
        [self.session addOutput:self.output];
    }
    
    // 条码类型
    self.output.metadataObjectTypes =@[AVMetadataObjectTypeQRCode];
    
    // Preview
    self.preview = [AVCaptureVideoPreviewLayer layerWithSession:self.session];
    self.preview.videoGravity =AVLayerVideoGravityResizeAspectFill;
    self.preview.frame =CGRectMake(0,0,self.view.frame.size.width,self.view.frame.size.height);
    
    [self.view.layer addSublayer:self.preview];

    left = CGRectGetWidth(self.view.frame) / 2 - 90;
    top = CGRectGetHeight(self.view.frame) / 2 - 90;

    _line = [[UIView alloc] initWithFrame:CGRectMake(left, top, 180, 2)];
    _line.backgroundColor = [UIColor lightGrayColor];
    [self.view addSubview:_line];
    
    //上
    UIView * view1 = [[UIView alloc]initWithFrame:CGRectMake(0, 0, self.view.bounds.size.width, top)];
    view1.backgroundColor = [UIColor lightTextColor];
    [self.view addSubview:view1];

     //左
    UIView * view2 = [[UIView alloc]initWithFrame:CGRectMake(0,top,left, self.view.bounds.size.height)];
    view2.backgroundColor = [UIColor lightTextColor];
    [self.view addSubview:view2];
    //下
    UIView * view3 = [[UIView alloc]initWithFrame:CGRectMake(left,self.view.bounds.size.height-top,self.view.bounds.size.width-left*2, top)];
    view3.backgroundColor = [UIColor lightTextColor];
    [self.view addSubview:view3];
    //右
    UIView * view4 = [[UIView alloc]initWithFrame:CGRectMake(self.view.bounds.size.width-left,top,left,self.view.bounds.size.height)];
    view4.backgroundColor = [UIColor lightTextColor];
    [self.view addSubview:view4];
    
    timer = [NSTimer scheduledTimerWithTimeInterval:.02 target:self selector:@selector(animation1) userInfo:nil repeats:YES];
    
}

-(void)animation1
{
    if (upOrdown == NO) {
        num ++;
        _line.frame = CGRectMake(left, top+2*num, 180, 2);
        if (2*num == 180) {
            upOrdown = YES;
        }
    }
    else {
        num --;
        _line.frame = CGRectMake(left, top+2*num, 180, 2);
        if (num == 0) {
            upOrdown = NO;
        }
    }
}
-(void)viewDidDisappear:(BOOL)animated{
    [super viewDidDisappear:animated];
    
}
- (void)viewWillAppear:(BOOL)animated;
{
    [super viewWillAppear:animated];
    [self.session startRunning];//出现view就开始扫码
    UILabel * label = [[UILabel alloc]initWithFrame:CGRectMake(0, 0, 200, 50)];
    label.textAlignment = 1;
    label.font = [UIFont systemFontOfSize:30];
    NSMutableAttributedString * toplabel1textAttributed = [[NSMutableAttributedString alloc]initWithString:@"高备扫一扫"];
    [toplabel1textAttributed addAttribute:NSForegroundColorAttributeName value:[UIColor orangeColor] range:NSMakeRange(0,2)];
    
    label.attributedText = toplabel1textAttributed;
    self.navigationItem.titleView =label;


}

#pragma mark AVCaptureMetadataOutputObjectsDelegate
- (void)captureOutput:(AVCaptureOutput *)captureOutput didOutputMetadataObjects:(NSArray *)metadataObjects fromConnection:(AVCaptureConnection *)connection
{
    NSString *stringValue;
    
    if ([metadataObjects count] >0) {
        AVMetadataMachineReadableCodeObject *metadataObject = [metadataObjects objectAtIndex:0];
        stringValue = metadataObject.stringValue;
    }
    [_session stopRunning];
    [self declassify:stringValue];
}
#pragma mark - http
//解密二维码扫描的结果
- (void)declassify:(NSString *)data {
    ViewController2 *viewC = [[ViewController2 alloc]init];
    viewC.url = data;
    [self.navigationController pushViewController:viewC animated:YES];
}


@end
